package jiaowuxitong

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/education/src/jiaowuxitong/model"
)

type school struct {
	Table
	modify string `name:"modify school_info" role:"void"`
	list   string `name:"list school_name auto" role:"void"`
}

func (s school) FindOrCreateByName(m *ice.Message, arg ...string) {
	if msg := m.Cmd(s, s.Select, model.NAME, arg[3], arg[0], arg[1]); msg.Length() == 0 {
		msg := m.Cmd(s, s.Insert, model.NAME, arg[3], arg[0], arg[1])
		arg[2], arg[3] = model.SCHOOL_UID, msg.Result()
	} else {
		arg[2], arg[3] = model.SCHOOL_UID, msg.Append(model.UID)
	}
}
func (s school) Modify(m *ice.Message, arg ...string) {
	s.Update(m, kit.Dict(model.INFO, m.Option(model.SCHOOL_INFO)), model.NAME, m.Option(model.SCHOOL_NAME))
}
func (s school) List(m *ice.Message, arg ...string) {
	if len(arg) == 0 {
		if m.IsTech() {
			s.Select(m, arg...)
		}
	} else {
		msg := s.Select(m.Spawn(), model.NAME, arg[0])
		m.Option(model.SCHOOL_NAME, msg.Append(model.NAME))
		m.Option(model.SCHOOL_INFO, msg.Append(model.INFO))
		m.Option(model.SCHOOL_AVATAR, msg.Append(model.AVATAR))
		m.Option(model.SCHOOL_BACKGROUND, msg.Append(model.BACKGROUND))
		msg.Table(func(value ice.Maps) {
			if value[model.AUTH_UID] != "" {
				m.Cmdy("web.team.renzhengshouquan.auth", value[model.AUTH_UID])
			}
		})
		kit.If(m.IsTech(), func() { m.Action(s.Modify) })
		m.Display("")
	}
}

func init() { ice.TeamCtxCmd(school{}) }
